/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __GAME_H
#define __GAME_H

#include "types.h"

class TGame
{
public:
	std::string iEngine;

	std::string iName;
	std::string iCategory;
	std::string iDescription;
	std::string iCloneOf;
	std::string iYear;
	std::string iManufacturer;
	int			iPlayers;
	int			iButtons;
	bool		iAlternatePlay = false;
	bool		iSimulatenousPlay = false;
	
	std::string EncodeGameID() const { return iEngine + ":" + iName; }
	
	static std::string DecodeNameFromGameID(const std::string& aGameID)
	{
		size_t pos = aGameID.find(':');
		if (pos != std::string::npos)
		{
			return aGameID.substr(pos+1);
		}
		return "";
	}
	
	static void DecodeGameID(const std::string& aGameID, std::string& aName, std::string& aEngineName)
	{
		size_t pos = aGameID.find(':');
		if (pos != std::string::npos)
		{
			aEngineName.assign(aGameID.substr(0, pos)); // skip ':' character
			aName.assign(aGameID.substr(pos+1));
		}
		else
		{
			aName.clear();
			aEngineName.clear();
		}
	}
};

typedef std::map<std::string,  TGame > TGameMap;

#endif // __GAME_H
