/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __DIALOG_GAME_INFO_H
#define __DIALOG_GAME_INFO_H

#include "sdldialog.h"
#include "sdlsimpletextwidget.h"

class GameInfoDialog : public sdl::Dialog
{
public:
	GameInfoDialog(const std::string& aGameInfo); 
	
private:
	void ApplyProperties();
	virtual void Setup() override;
	
	// needed to override scroll behavior in sdl::Dialog, let SimpleText (via sdl::ScrollableContainer) do its own scrolling 
	virtual bool HasInput() const override { return false; }
	void OnDialogExit(bool aSuccess) override {}
	
	void FormatGameInfoText(const std::string& aGameInfoText, std::string& aFormattedGameInfoText);
	void ProcessLine(const std::string& aLine, std::string& aFormattedGameInfoText);

	sdl::SimpleTextWidget iSimpleTextWidget;
};

#endif // __DIALOG_GAME_INFO_H