/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __RESOURCE_FILE_JOYSTICK_PROPERTIES_H
#define __RESOURCE_FILE_JOYSTICK_PROPERTIES_H

#include "resourcefile.h"
#include "sdlthemeproperties.h"
#include "sdljoyproperties.h"

class ResourceFileJoystickProperties : public ResourceFile
{
public:
	static ResourceFileJoystickProperties Instance;
	
	void AddResources(sdl::JoystickProperties& aJoystickProperties) 
	{ 
		Reset();
		
		iResources.Add("Joystick.Navigation.HatLeft", aJoystickProperties.Navigation.iHatLeft);
		iResources.Add("Joystick.Navigation.HatRight", aJoystickProperties.Navigation.iHatRight);
		iResources.Add("Joystick.Navigation.HatUp", aJoystickProperties.Navigation.iHatUp);
		iResources.Add("Joystick.Navigation.HatDown", aJoystickProperties.Navigation.iHatDown);
		iResources.Add("Joystick.Navigation.Joystick", aJoystickProperties.Navigation.iJoystick);
		
		iResources.Add("Joystick.Navigation.Speed.ScrollSpeedInMs", aJoystickProperties.Navigation.Speed.iScrollSpeedInMs);
		iResources.Add("Joystick.Navigation.Speed.FastScrollDelayInMs", aJoystickProperties.Navigation.Speed.iFastScrollDelayInMs);
		iResources.Add("Joystick.Navigation.Speed.FastScrollSpeedInMs", aJoystickProperties.Navigation.Speed.iFastScrollSpeedInMs);
		
		for (auto &button : aJoystickProperties.iButtons)
			AddButton(button);
	}

private:
	void AddButton(sdl::JoystickProperties::TButton& aButton)
	{
		iResources.Add(std::string("Joystick.Button") + aButton.iName + ".ButtonId", aButton.iJoystickButtonId);
		iResources.Add(std::string("Joystick.Button") + aButton.iName + ".JoystickId", aButton.iJoystickId);
	}
	
};

#endif // __RESOURCE_FILE_JOYSTICK_PROPERTIES_H