/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __RESOURCE_FILE_USER_PROPERTIES_H
#define __RESOURCE_FILE_USER_PROPERTIES_H

#include "resourcefile.h"
#include "sdluserproperties.h"
#include "userproperties.h"

class ResourceFileUserProperties : public ResourceFile
{
public:
	static ResourceFileUserProperties Instance;

	void AddResources(sdl::UserProperties& aUserProperties) 
	{
		iResources.Add("Audio.EnabledEvents", aUserProperties.iAudioProperties.iEnabledEvents);
		iResources.Add("Audio.Volume", aUserProperties.iAudioProperties.iVolume);
		iResources.Add("Audio.Samples", aUserProperties.iAudioProperties.iSamples);
		iResources.Add("Audio.Mute", aUserProperties.iAudioProperties.iMute);
	}
	
	void AddResources(UserProperties& aUserProperties)
	{
		iResources.Add("RecentGames.Enabled", aUserProperties.iRecentGames.iEnabled);
		iResources.Add("RecentGames.Max", aUserProperties.iRecentGames.iMax);
		
		iResources.Add("FavoritesGames.Enabled", aUserProperties.iFavsGames.iEnabled);
		iResources.Add("FavoritesGames.Max", aUserProperties.iFavsGames.iMax);
		
		iResources.Add("FilterGames.MaxPlayers", aUserProperties.iFilterGames.iMaxPlayers);
		iResources.Add("FilterGames.MaxButtons", aUserProperties.iFilterGames.iMaxButtons);
		iResources.Add("FilterGames.SimultaneousPlayers", aUserProperties.iFilterGames.iSimultaneousPlayers);
		
		iResources.Add("GameCategories.Exclude", aUserProperties.iGameCategories.iExclude);
		iResources.Add("GameEngines.Exclude", aUserProperties.iGameEngines.iExclude);
		
		iResources.Add("Video.Enabled", aUserProperties.iVideoSetting.iVideoEnabled);
		iResources.Add("Video.MuteAudio", aUserProperties.iVideoSetting.iMuteAudio);
		iResources.Add("Video.AudioVolume", aUserProperties.iVideoSetting.iAudioVolumeDuringVideo);
		iResources.Add("Video.StartAfterDelay", aUserProperties.iVideoSetting.iStartAfterDelay);
		iResources.Add("Video.TimeLabel", aUserProperties.iVideoSetting.iTimeLabel);
		
		iResources.Add("Theme", aUserProperties.iThemeName);
		iResources.Add("LastMenu.Name", aUserProperties.iLastMenuName);
		iResources.Add("LastMenu.MenuItem", aUserProperties.iLastMenuItemName);
	}
	
	void AddResources(UserProperties& aUserProperties, sdl::UserProperties& aSDLUserProperties) 
	{ 
		Reset();
		
		AddResources(aUserProperties);
		AddResources(aSDLUserProperties);
	}
};


#endif // __RESOURCE_FILE_USER_PROPERTIES_H
