/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#include "systemmenumodel.h"
#include "thememenumodel.h"
#include "appmenudefs.h"

void SystemMenuModel::Construct()
{
	iMenu = new sdl::Menu("System", KMenuTypeSystem);
	
	sdl::Menu* systemMenuMenu = new sdl::Menu("System menus", KMenuTypeSettingsSystemMenus);
	systemMenuMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdConfigureFavsMenu));
	systemMenuMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdConfigureRecentGamesMenu));
	systemMenuMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdClearRecentGames));
	systemMenuMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdClearFavs));
	
	sdl::Menu* joystickMenu = new sdl::Menu("Joystick", KMenuTypeSystem);
	joystickMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdConfigureJoystickNavigation));
	joystickMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdConfigureJoystickScrollSpeed));
	joystickMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdConfigureJoystickButtons));
	
	sdl::Menu* gamesMenu = new sdl::Menu("Games", KMenuTypeSystem);
	gamesMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdFilterCategories));
	gamesMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdFilterGameEngines));
	
	sdl::Menu* audioMenu = new sdl::Menu("Audio", KMenuTypeSystem);
	audioMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdAudioEvents));
	audioMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdAudioVolume));

	sdl::Menu* videoMenu = new sdl::Menu("Video", KMenuTypeSystem);
	videoMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdVideoSettings));
	
	iMenu->AddMenu(joystickMenu);
	iMenu->AddMenu(gamesMenu);
	iMenu->AddMenu(systemMenuMenu);
	iMenu->AddMenu(audioMenu);
	iMenu->AddMenu(videoMenu);
	iMenu->AddMenu(iThemeMenuModel.GetMenu());
	iMenu->AddMenuItem(new sdl::MenuItem(KMenuCmdAbout));
}

