/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __THEME_MENU_CONTROLLER_H
#define __THEME_MENU_CONTROLLER_H

#include "sdlimenulistener.h"
#include "thememodel.h"

class ThemeMenuModel;

class ThemeMenuController :  public sdl::IMenuItemListener
{
public:
	ThemeMenuController(ThemeModel& aThemeModel) : iThemeModel(aThemeModel) {}
protected:
	virtual void MenuItemHighlighted(const sdl::MenuItem& aMenuItem) override { }
	virtual void MenuItemCommand(const sdl::MenuItem& aMenuItem, const sdl::TCommand& aCommand) override;
	virtual void MenuListChanged(sdl::Menu& aMenu) override {}
	
private:
	ThemeModel& iThemeModel;
};

#endif // __THEME_MENU_CONTROLLER_H