/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#include "thememenumodel.h"
#include "thememodel.h"
#include "appmenudefs.h"

void ThemeMenuModel::Construct()
{
	iMenu = new sdl::Menu(KMenuNameTheme, KMenuTypeSettingsThemeMenu);
	PopulateMenu(iMenu);
}

void ThemeMenuModel::PopulateMenu(sdl::Menu* aMenu)
{
	std::string currentTheme = iThemeModel.GetCurrentThemeName();
	TStringList stringList;
	iThemeModel.GetThemeList(stringList);
	for (auto &themeName : stringList)
	{
		std::string themeCommand = themeName;
		if (themeName.compare(currentTheme) == 0)
			themeName += " (current)";
		aMenu->AddMenuItem(new sdl::MenuItem(themeName, themeCommand));
	}
}

