/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __THEME_MODEL_H
#define __THEME_MODEL_H

#include "types.h"

class ThemeModel
{
public:
	static std::string GetCurrentThemeName();
	static std::string GetCurrentThemeDirName();
	static std::string GeThemeDirName(const std::string& aThemeName);
	static std::string GetThemeFileName() { return "theme.rc"; }
	static bool TestAndResetHasThemeChangedLastRun(std::string &aThemeName);
	
	void GetThemeList(TStringList& aStringList);
	void ChangeTheme(const std::string& aThemeName);
	bool ThemeChanged() { return iThemeChanged; }
private:
	bool 					iThemeChanged = false;
};

#endif // __THEME_MODEL_H