/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#include "sdlbase.h"

using namespace sdl;

int TPerformance::sLevel = 0;

void TColor::Gradient(int aGradient)
{
	Uint8 r = (Uint8) GetR();
	Uint8 g = (Uint8) GetG();
	Uint8 b = (Uint8) GetB();
	
	GradientComponent(aGradient, r);
	GradientComponent(aGradient, g);
	GradientComponent(aGradient, b);
	
	iColor = MakeColor(r, g, b);
}

void TColor::GradientComponent(int aGradient, Uint8& aComponent)
{
	if (aGradient > 0)
	{
		if (255 - aComponent > aGradient)
			aComponent += aGradient;
		else
			aComponent = 255;
	}
	else
	{
		aGradient *= -1;
		if (aComponent > aGradient)
			aComponent -= aGradient;
		else
			aComponent = 0;
	}
}

void TRect::ScaleKeepingAspectRatio(const TRect& aTargetRect)
{
	float diffX = (float) aTargetRect.iSize.iWidth / (float) iSize.iWidth;
	float diffY = (float) aTargetRect.iSize.iHeight / (float) iSize.iHeight;
	
	float diff = (diffX < diffY) ? diffX : diffY;
	
	iSize.iWidth *= diff;
	iSize.iHeight *= diff;
}
