/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_BUTTON_BAR_H
#define __SDL_BUTTON_BAR_H

#include "sdlcore.h"
#include "sdlcontainer.h"
#include "sdlbuttonwidget.h"
#include "sdllayout.h"

namespace sdl
{
	class ButtonBar : public Container
	{
	public:
		void AddButton(ButtonWidget& aButton, bool aOwnership=false)	{ AddWidget(aButton, aOwnership); }
		virtual void Layout() override									{ LayoutManager::RowLayout(*this, LayoutManager::THorAlignment::ECenter); }
		virtual int GetMinimumHeight() const override					{ return (iWidgets.size() > 0) ? iWidgets[0]->GetMinimumHeight() + 10 : 0; }
		virtual bool HandleCommandMyself(TCommand aCommand);
	};
}

#endif // __SDL_BUTTON_BAR_H