/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_JOY_PROPERTIES_H
#define __SDL_JOY_PROPERTIES_H

#include "platform.h"
#include "sdlcommands.h"
#include <vector>

namespace sdl
{
	class JoystickProperties;
	extern JoystickProperties SDLJoystickProperties;
	
	class JoystickProperties
	{
	public:
		class TNavigation
		{
		public:
			int iHatLeft = 0;
			int iHatRight = 0;
			int iHatUp = 0;
			int iHatDown = 0;
			int iJoystick = -1;
			
			class TSpeed
			{
			public:
				int iScrollSpeedInMs = 150;
				int iFastScrollDelayInMs = 2000;
				int iFastScrollSpeedInMs = 50;
			};
			TSpeed Speed;
		};
		TNavigation Navigation;
		
		class TButton
		{
		public:
			TButton(int aJoystickId, int aJoystickButtonId, const std::string& aName, int aCommand) 
			: iJoystickId(aJoystickId), iJoystickButtonId(aJoystickButtonId), iName(aName), iCommand(aCommand) {}
			
			int 		iJoystickId;
			int 		iJoystickButtonId;
			std::string iName;
			int 		iCommand;
		};
		
		std::vector<TButton> iButtons = 
		{
			{-1, -1, "Select",	TCommand::ESelect}, 
			{-1, -1, "Back",	TCommand::EBack},  
			{-1, -1, "Page up",	TCommand::EPageUp},  
			{-1, -1, "Page down",	TCommand::EPageDown},  
			{-1, -1, "Delete",	TCommand::EDelete}
		};
	};
	
	JoystickProperties DECLARE_ONCE SDLJoystickProperties;
	
	
} // namespace sdl

#endif // __SDL_JOY_PROPERTIES_H