/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_LAYOUT_H
#define __SDL_LAYOUT_H

#include "sdlcore.h"

namespace sdl 
{
	class Container;
	
	class LayoutManager
	{
	public:
		enum class THorAlignment
		{
			ELeft = 0,
			ERight,
			ECenter
		};
		
		enum class TVertAlignment
		{
			ETop = 0,
			EBottom,
			ECenter
		};
		
		static void GridLayout(Container& aContainer, int aColumns, bool aResizeHeight = true);
		static void RowLayout(Container& aContainer, THorAlignment aHorAlignment, TVertAlignment aVertAlignment = TVertAlignment::EBottom);
		static void ListLayout(Container& aContainer);
	};
}

#endif // __SDL_LAYOUT_H