/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SDL_USER_FEEDBACK_MANAGER_H
#define __SDL_USER_FEEDBACK_MANAGER_H

namespace sdl 
{
	class UserFeedbackManager
	{
	public:
		enum TEvent
		{
			EUserStartup = 0,
			EUserInputOk,
			EUserInputCancel,
			EDialogOk,
			EDialogCancel,
			EMenuVerticalScroll,
			EMenuHorizontalScroll,
			EMenuEndList,
			ECustom = 1000
		};
		
		class IUserFeedbackHandler
		{
		public:
			virtual void HandleEvent(const TEvent& aEvent) = 0;
		};
		
		static void SendUserFeedbackEvent(const TEvent& aEvent)
		{
			if (UserFeedbackManager::iUserFeedbackHandler)
				UserFeedbackManager::iUserFeedbackHandler->HandleEvent(aEvent);
		}
		
		static void RegisterUserFeedbackHandler(IUserFeedbackHandler& aUserFeedbackHandler)
		{
			UserFeedbackManager::iUserFeedbackHandler = &aUserFeedbackHandler;
		}
		
	private:
		static IUserFeedbackHandler* iUserFeedbackHandler;
	};
}

#endif // __SDL_USER_FEEDBACK_MANAGER_H