/*******************************************************************
 * 
 *  Author: Peter van Sebille (peter@yipton.net)
 *
 *  (c) Copyright 2016, Peter van Sebille
 *  All Rights Reserved
 *
 *******************************************************************/

#ifndef __SIMPLE_TEXT_VIEW_H
#define __SIMPLE_TEXT_VIEW_H

#include "simpletextmodel.h"

namespace simpletext
{

class IViewRenderer
{
public:
	virtual int RenderWord(int aX, int aY, const std::string& aWord, const TCharFormat& aCharFormat) = 0;
};

class View
{
public:
	View(Model& aModel) : iModel(aModel) {}
	~View() {}

	void Layout(int aWidth, IFontProvider& aFontProvider);
	void RenderLine(IViewRenderer& aViewRenderer, int aLine, int aX, int aY, int aWidth);
	
	Model& 	iModel;
	
private: 
	int GetRenderHeight(int aStartLine, int aNumberOfLines); 
};

}

#endif // __SIMPLE_TEXT_VIEW_H